<?php
/*
Plugin Name: X IP Blacklist
Description: xmlrpcに不正アクセスしてきたIPをブラックリストとして記録してブロックします。【注意】xmlrpcサービスを使うプラグインと同時に使うことはできません。ブラックリストをリセットするには、FTPでログインして「/wp-content/uploads/black-ip-list」フォルダを削除してください。
Version: 0.1
Author: x-nonce
Author URI:
 */

/* ------------------------------------------------------------ */

// リモートのIP
define('XBIL_REMOTE_IP', getenv('REMOTE_ADDR'));

// ログファイルの保存場所
$upload_dir = wp_upload_dir();
define('XBIL_DIR', $upload_dir['basedir'] . '/black-ip-list');

// ログファイル
define('XBIL_LOGFILE', XBIL_DIR . '/' . XBIL_REMOTE_IP . '.txt');

/* ------------------------------------------------------------ */

// 作業ディレクトリ作成
if (!file_exists(XBIL_DIR)) {
    mkdir(XBIL_DIR);
}

/* ------------------------------------------------------------ */

// もしファイルが存在したらアクセス禁止
if (file_exists(XBIL_LOGFILE)) {
    wp_die('Your IP address is on the blacklist.');
}

/* ------------------------------------------------------------ */

// もしxmlrpcにアクセスがあったらファイル作成
if (preg_match('/xmlrpc\.php/', getenv('REQUEST_URI'))) {
    file_put_contents(XBIL_LOGFILE, '1');
}
